#***************************************************************#
#**                                                           **#
#**   Gragas Darius de Oliveira Swain                         **#
#**   1337001                                                 **#
#**   Exercício-Programa Final                                **#
#**   Professor: Hitoshi                                      **#
#**   Turma: 01                                               **#
#**                                                           **#
#***************************************************************#


#################################################################
#                                                               #
#                      Figurinhas da copa                       #
#                                                               #
#                                                               #
#    Programa para calcular qual o custo de se preencher        #
#    um álbum de figurinhas.                                    #
#                                                               #
#################################################################

import sys
from random import *


seed() 

PRECO_PACOTE = 4.0

def compra_pacote():
    '''
    (None) -> tuple

    Simula a compra de um pacote de figurinhas.
    Retorna uma tupla contendo as figurinhas do pacote.
    '''
    pacote = list()
    
    for i in range(4):
        figura = randint(0, N_FIGURINHAS - 1) 
        pacote.append(figura)
    return tuple(pacote)

def simulacao():
    '''
    (None) -> None

    Simula o processo de completar um álbum de figurinhas.
    '''
    print("------ INICIANDO SIMULAÇÃO -------")
    global N_FIGURINHAS 
    
    N_FIGURINHAS = int(sys.argv[1])
    pacotes = 0

    for i in range(150): 
        diferentes = 0
        
        album = [0 for i in range(N_FIGURINHAS)]

        while diferentes < N_FIGURINHAS:
            pacote = compra_pacote()
            pacotes = pacotes + 1

            for figura in pacote:
                if not (figura in album):
                    album[figura] = 1
                    diferentes = diferentes + 1

    print("Número de figurinhas por álbum: %d." % N_FIGURINHAS)
    print("Quantidade média de pacotes comprados: %.2f." % (pacotes/150))
    print("Média de dinheiro gasto para completar um álbum: %.2f reais." % ((pacotes/150) * PRECO_PACOTE))
    print("")
    print("-------- FIM DE SIMULAÇÃO --------")

if __name__ == '__main__':

    if len(sys.argv) == 1:
        print("Uso do simulador: python3 simulador1.py <num_figurinhas_por_album>")
        print("Exemplo:")
        print("USUARIO@COMP:~/pasta/122-17$ python3 simulador1.py 400")
        exit(1)
    simulacao()
