"""
  AO PREENCHER ESSE CABEÇALHO COM O MEU NOME E O MEU NÚMERO USP, 
  DECLARO QUE SOU O ÚNICO AUTOR E RESPONSÁVEL POR ESSE PROGRAMA. 
  TODAS AS PARTES ORIGINAIS DESSE EXERCÍCIO PROGRAMA (EP) FORAM 
  DESENVOLVIDAS E IMPLEMENTADAS POR MIM SEGUINDO AS INSTRUÇÕES
  DESSE EP E QUE PORTANTO NÃO CONSTITUEM DESONESTIDADE ACADÊMICA
  OU PLÁGIO.  
  DECLARO TAMBÉM QUE SOU RESPONSÁVEL POR TODAS AS CÓPIAS
  DESSE PROGRAMA E QUE EU NÃO DISTRIBUI OU FACILITEI A
  SUA DISTRIBUIÇÃO. ESTOU CIENTE QUE OS CASOS DE PLÁGIO E
  DESONESTIDADE ACADÊMICA SERÃO TRATADOS SEGUNDO OS CRITÉRIOS
  DIVULGADOS NA PÁGINA DA DISCIPLINA.
  ENTENDO QUE EPS SEM ASSINATURA NÃO SERÃO CORRIGIDOS E,
  AINDA ASSIM, PODERÃO SER PUNIDOS POR DESONESTIDADE ACADÊMICA.

  Nome : Jon Mormont
  NUSP : 1000456
  Turma: 01
  Prof.: Coelho

  EP4 de MAC2166 - 2015 S1
  Calculadora Polonesa

  Referências: Com exceção das rotinas fornecidas no esqueleto
  e em sala de aula, caso você tenha utilizado alguma refência,
  liste-as abaixo para que o seu programa não seja considerado
  plágio ou irregular.
  
  Exemplo:
  - O algoritmo Quicksort foi baseado em http://www.ime.usp.br/~pf/algoritmos/aulas/quick.html

  """

"""
  NAO MODIFIQUE AS FUNÇÕES E CLASSES DEFINIDAS NESTE ESQUELETO

  A estrutura deste esqueleto é definida a seguir.
  Não altere esta estrutura.
  As partes deste EP que você deve escrever estão entre ** **

  1  CONSTANTES                
  2  FUNÇÕES DADAS
  3  ** FUNÇÕES QUE VOCÊ PRECISA ESCREVER E USAR **
  4  OUTRAS FUNÇÕES QUE VOCÊ QUISER ESCREVER E USAR
  5  CLASSES DADAS
  6  ** CLASSES QUE VOCÊ PRECISA ESCREVER E USAR **
  7  OUTRAS CLASSES QUE VOCÊ QUISER ESCREVER
  8  CHAMADA DA MAIN()
"""
######################################################################
### 1  CONSTANTES
######################################################################

BRANCOS    = [' ', '\n', '\t']
DIGITOS    = "0123456789."

OPERADORES = "+-*/%^=!"
OP_ATR = '='
OP_ADD = '+'
OP_SUB = '-'
OP_MUL = '*'
OP_DIV = '/'
OP_MOD = '%'
OP_POT = '^'  # potência: você pode usar ** do Python
OP_NOT = '!'  # troca o sinal

# OUTRAS CONSTANTES SE DESEJAR


########################################################################
### 2  FUNCÕES DADAS
########################################################################

def main():
    """Programa principal"""
    
    menu()    
    calc  = Calculadora()
    exp = input("exp>> ")
    
    while exp != "fim":
        if exp == "var":
            calc.imprima_dicionario() 
        elif exp == "dep":
            calc.troca_modo_depuracao() # liga se desligado e desliga se ligado
        else:
            res = calc.calcula_expressao(exp)
            if res is not None:
                print("res:  ", res)
            else:
                print("Não consegui calcular o valor de ", exp)
        exp = input("\nexp>> ")
        
    print("OBRIGADO POR UTILIZAR A CALCULADORA POLONESA\n")
    
    
###===================================================================

def menu():
    """(None) -> None
       mostra o menu de opções da calculadora
    """
    print()
    print("==================================================")
    print("     C A L C U L A D O R A    P O L O N E S A     ")
    print("==================================================")
    print()    
    print('Digite: ')
    print('  - uma expressão em notação polonesa como "2 3 + A ="; ou')
    print('  - "dep" para ligar/desligar o modo de depuração; ou')
    print('  - "var" para imprimir a lista de variáveis no escopo atual; ou')
    print('  - "fim" para terminar.')
    print()
    print('Operações possíveis:')
    print('  - as cinco operações aritméticas básicas: + - * / %')
    print('  - potência: ^')
    print('  - negação : ! (troca de sinal)')
    print('  - atribuição: = ')
    print()

###===================================================================

def imprima_tokens(tokens):
    """ (list) -> None
        Recebe uma lista (pilha ou fila) de tokens e a imprime
        """
    if len(tokens) == 0:
        print('[]')
    else:
        s = '[' + str(tokens[0])
        for t in tokens[1:]:
            s += ',' + str(t)
        print(s+']')
            
########################################################################
###/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
###
### 3  ** FUNÇÕES QUE VOCÊ PRECISA ESCREVER E USAR **
###
###\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
########################################################################

def tokeniza(exp):
    """ (str) -> list
        Recebe uma expressão em notação polonesa e retorna
        uma lista de tokens.
        Use a classe Token definida nesse esqueleto sem modificá-la, e
        use a função imprima_tokens para testar essa função.
        Você pode converter todos os números para reais.
        """
    for c in exp:

        tokens = []
        s = ""
        
        if c != BRANCOS[0]:
            s += c
            
        else:
            
            for d in DIGITOS:
                if s == d:
                    token = Token('N', c)
                    tokens.append(token)

            for op in OPERADORES:
                if s == op:
                    token = Token('O', c)
                    tokens.append(token)
                        
            token = Token('V', c)
            tokens.append(token)
           
    return tokens



                    
######################################################################
### 4  OUTRAS FUNÇÕES QUE VOCÊ QUISER ESCREVER E USAR
######################################################################


######################################################################
### 5  CLASSES DADAS QUE VOCÊ NÃO DEVE MODIFICAR
######################################################################

class Token:
    """ Token é um elemento da expressão polonesa,
        que pode ser colocado na lista de tokens ou 
        empilhado na pilha de execução.
        O tipo pode ser 'N', 'V' ou 'O'.
        """
    def __init__(self, t, v):
        self.tipo  = t
        self.valor = v

    def __str__(self):
        if self.tipo == 'N':
            return "N(%.3f)"%(self.valor)
        elif self.tipo == 'V':
            return "V(%s)"%(self.valor)
        else: # self.tipo == 'O':
            return "O(%s)"%(self.valor)
    
########################################################################
###/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
###
### 6  ** CLASSES QUE VOCÊ PRECISA ESCREVER E USAR **
###
###\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
########################################################################

class Calculadora:
    """ Essa classe possui os métodos para calcular o valor
        de uma expressão polonesa contendo números,
        variáveis e operadores.
        Essa classe deve se comportar de acordo com o especificado
        pela função main().
        NÃO ALTERE A FUNÇÃO MAIN().
        """

    def troca_modo_depuração(self):
        if self.depuração == False:
            self.depuração = True
        elif self.depuração == True:
            self.depuração = False

    

        
    def calcula_expressao(self, exp):
        
        tokens = tokeniza(exp)

        #imprima_tokens(tokens)
        
        pilha = []

        for token in tokens:

            if token.tipo == 'V':
                pilha.append(token)

            if token.tipo == 'N':
                pilha.append(token)

            else:

                if token.valor == OP_ADD:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1+v2))
                    pilha.append(result)

                elif token.valor == OP_SUB:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1-v2))
                    pilha.append(result)

                elif token.valor == OP_MUL:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1*v2))
                    pilha.append(result)
                    
                elif token.valor == OP_DIV:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1/v2))
                    pilha.append(result)
                    
                elif token.valor == OP_POT:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1**v2))
                    pilha.append(result)
                
                elif token.valor == OP_MOD:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    result = Token('N', (v1%v2))
                    pilha.append(result)
                    
                elif token.valor == OP_NOT:
                    v1 = tokens.pop().valor
                    result = Token('N', (v1*(-1)))
                    pilha.append(result)
                    
                else:
                    v1 = tokens.pop().valor
                    v2 = tokens.pop().valor
                    dicionario.insere(v2,v1)

                    return v1
    
######################################################################
### 7  OUTRAS CLASSES QUE VOCÊ QUISER ESCREVER
######################################################################
class Dicionário:
    def __init__(self):
        self.chaves = []
        self.valores = []
        
    def __str__(self):
        tam = len(self.chaves)
        if tam == 0:
            return "{}"
        dic = "{%s:%s"%(str(self.chaves[0]), str(self.valores[0]))
        for i in range(1,tam):
            dic += "{,%s:%s}"%(str(self.chaves[i]), str(self.valores[i]))
        dic += "}"
        return dic


    def procura(self, c):
        """chave -> int"""
        for i in range(len(self.chaves)):
            if self.chaves[i] == c:
                return i
        return -1
        
    def insere(self, c, v):
        """chave,valor -> none"""
        i = self.procura(c)
        if i == -1:
            self.chaves.append(c)
            self.valores.append(v)
        else:
            self.valores[i] = v

    def pegaValor(self, c):
        """(chave) -> valor"""
        i = self.procura(c)
        if i == -1:
            return None
        else:
            return self.valores[i]

######################################################################
### 8  CHAMADA DA MAIN()
######################################################################
    
main()
